/***********************************************************************
 *               Copyright (C) 1995 Joe English
 *                   Freely redistributable
 ***********************************************************************
 *
 * File:	tclcost.h
 * Author:	Joe English
 * Created:	Feb 1995
 * Description:	Bag of declarations, misc. macros.
 *
 * $Date: 97/02/10 15:59:01 $
 * $Revision: 1.11 $
 * $Locker:  $
 */


#ifndef TCLCOST_H
#define TCLCOST_H 1

#ifndef COSTGLOBAL
#define COSTGLOBAL extern
#define INIT(x)
#else
#define INIT(x)	= (x)
#endif

COSTGLOBAL ESISNode current_node INIT(0);
COSTGLOBAL ESISStream current_document INIT(0);

/*+++
 * Convenience macros:
 */

#define CMDPROC(name) \
int name(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])

#define CHECKNARGS(nargs,argusage) \
    if (argc != nargs+1) { \
	Tcl_AppendResult(interp, "wrong #args\n", NULL); \
	Tcl_AppendResult(interp, "Usage: ", argv[0], " ", argusage, NULL); \
	return TCL_ERROR; \
    }

#define CHECKCURNODE \
    if (!current_node) { \
	Tcl_AppendResult(interp, argv[0], ": no current node", NULL); \
	return TCL_ERROR; }

/*+++
 * Cost routines:
 */

extern int CostEval(Tcl_Interp *interp, ESISNode nd, char *expr);

typedef struct CQAssoc *CQAssoc, CQAssocRec;

extern CQAssoc assocConstructor(Tcl_Interp *interp, char *str);
extern void assocDestructor(ClientData);
extern CMDPROC(assocProc);

/*+++ External commands:
*/
extern CMDPROC(DefineSubstProc);
extern CMDPROC(DefineEnvironmentProc);

/*+++ Initialization:
*/
#ifdef __WIN32__
#	define EXPORT __declspec(dllexport)
#else
#	define EXPORT
#endif
extern int EXPORT Cost_Init(Tcl_Interp *interp);

#endif /*TCLCOST_H*/
